<?php
// Adjust these settings to fit your iTop installation
// iTop Server location
define('ITOP_SERVER_URL', 'https://localhost/webservices/itop.wsdl.php');
// Valid credentials for connecting to iTop
define('ITOP_USERNAME', 'admin');
define('ITOP_PASSWORD', 'admin2');
// Default settings for creating the incident ticket
define('DEFAULT_IMPACT', 2); // 1 = department, 2 = service, 3 = person
define('DEFAULT_URGENCY', 2); // 1 = high, 2 = medium, 3 = low
define('DEFAULT_CALLER_NAME', 'Dali');
define('DEFAULT_ORGANIZATION_NAME', 'Demo');
define('DEFAULT_SERVICE_NAME', 'HW Monitoring');
define('DEFAULT_SERVICE_SUBCATEGORY', 'HW Troubleshooting');
define('DEFAULT_WORKGROUP_NAME', 'Hardware support');
// End of instance-specific parameters

define ('DEBUG', false); // Set to true to see the actual SOAP enveloppe output

# Parameters from Nagios when executing automatic actions on alarms
$sHost=$argv[1]; # $HOSTNAME$
$sService=$argv[2]; #$SERVICEDESC$
$sServiceStatus=$argv[3]; # $SERVICESTATE$
$sServiceStateType=$argv[4]; # $SERVICESTATETYPE$
$sServiceMessage=$argv[5]; # $LONGSERVICEOUTPUT$

// Main program
require_once(dirname(realpath(__FILE__)).'/itopsoaptypes.class.inc.php');

echo "===== create_ticket.php called =====\n";

$sInitial = $sServiceMessage;
echo "$sHost - $sService - $sServiceStatus - $sServiceStateType - $sServiceMessage\n";

if (!isset($aSOAPMapping)) // iTop 1.0 and 1.0.1, defined in itopsoaptypes.class.inc.php
{
	$aSOAPMapping = SOAPMapping::GetMapping(); // iTop 1.0.2 and above, defined in itopsoaptypes.class.inc.php
}
if (( $sServiceStatus != 'OK') && ($sServiceStatus != 'UP'))
{
	switch($sServiceStateType)
	{
		case 'HARD' :
		$oSoapClient = new SoapClient(
			ITOP_SERVER_URL,
			array(
				'trace' => 1,
				'classmap' => $aSOAPMapping,
			)
		);
		$sDescription = 'The service '.$sService.' is in state '.$sServiceStatus;

		$oRes = $oSoapClient->CreateIncidentTicket(
			ITOP_USERNAME, /* login */
			ITOP_PASSWORD, /* password */
			$sDescription, /* Title */
			$sInitial, /* Description */
			new SOAPExternalKeySearch(array(new
			SOAPSearchCondition('name', DEFAULT_CALLER_NAME))), /* caller */
	
			new SOAPExternalKeySearch(array(new
			SOAPSearchCondition('name', DEFAULT_ORGANIZATION_NAME))), /* customer */
	
			new SOAPExternalKeySearch(array(new SOAPSearchCondition('name', DEFAULT_SERVICE_NAME))), /* Service */
			new SOAPExternalKeySearch(array(new SOAPSearchCondition('name',	DEFAULT_SERVICE_SUBCATEGORY))), /* Sub category */
			'', /* product */
			new SOAPExternalKeySearch(array(new SOAPSearchCondition('name',	DEFAULT_WORKGROUP_NAME))), /* workgroup */
			array(new SOAPLinkCreationSpec('Device', array(new SOAPSearchCondition('name', $sHost)), array())), /* impacted cis */
			DEFAULT_IMPACT, /* impact*/
			DEFAULT_URGENCY /* urgency */
		);
		echo "\n";
		print_r($oRes);
		echo "\n";

		if (DEBUG)
		{
			print "\n";
			print "Request: \n".$oSoapClient->__getLastRequest()."\n";
			print "Response: \n".$oSoapClient->__getLastResponse()."\n";
			print "\n";
		}
		break;
		
		default:
		echo "Service State Type \"$sServiceStateType\" != \"HARD\". No action taken.\n";
	}
}
?>
